You can not select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.

13 年之前
13 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
13 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
13 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
13 年之前
12 年之前
13 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
13 年之前
12 年之前
13 年之前
12 年之前
12 年之前
12 年之前
12 年之前
13 年之前
12 年之前
12 年之前
12 年之前
13 年之前
12 年之前
13 年之前
12 年之前
13 年之前
12 年之前
13 年之前
13 年之前
13 年之前
13 年之前
12 年之前
13 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
12 年之前
123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709710711712713714715716717718719720721722723724725726727728729730731732733734735736737738739740741742743744745746747748749750751752753754755756757758759760761762763764765766767768769770771772773774775776777778779780781782783784785786787788789790791792793794795796797798799
  1. #!/bin/bash
  2. # If not running interactively, don't do anything
  3. [[ $- != *i* ]] && return
  4. ##########################################
  5. null(){
  6. "$@" >/dev/null 2>&1
  7. }
  8. __try_exec(){
  9. type $1 >/dev/null 2>&1 && "$@"
  10. }
  11. ##########################
  12. # system type
  13. alias ismsys=false
  14. alias iscygwin=false
  15. alias iswindows=false
  16. alias isdarwin=false
  17. alias islinux=false
  18. alias with_coreutils=false # for mac
  19. case `uname` in
  20. (MINGW*) alias ismsys=true ;;
  21. (CYGWIN*) alias iscygwin=true ;;
  22. (Darwin*) alias isdarwin=true ;;
  23. (Linux*) alias islinux=true ;;
  24. esac
  25. null ls --version && alias with_coreutils=true
  26. ( ismsys || iscygwin ) && alias iswindows=true
  27. #################################
  28. if false iswindows
  29. then
  30. export PAGER='tr -d \\r | less'
  31. else
  32. export PAGER="less"
  33. fi
  34. export LESS="-iRMX"
  35. if null type vim
  36. then
  37. export EDITOR=vim
  38. else
  39. export EDITOR=vi
  40. fi
  41. export LANG=ja_JP.UTF-8
  42. export LC_MESSAGES=C
  43. # export CDPATH=".:~"
  44. export VISUAL="$EDITOR"
  45. export GIT_PAGER="less -F"
  46. export GIT_EDITOR="$EDITOR"
  47. if test -n "$TMUX" && \
  48. echo $TERM | grep screen >/dev/null 2>&1 && \
  49. tmux display -p '#{client_termname}' | grep 256color >/dev/null 2>&1
  50. then
  51. TERM=screen-256color
  52. fi
  53. test -z "$TMP" && export TMP=/tmp/${USER}-tmp
  54. mkdir -p "$TMP"
  55. ! iswindows && null type stty && {
  56. stty stop undef # unbind C-s to stop displaying output
  57. # stty erase '^h'
  58. }
  59. if iswindows; then
  60. # export PS1=" \[\e[32m\]\u@\H \[\e[33m\]\w\[\e[0m\] \d \t\n\s \# \j \$ "
  61. # export PS1=" [\[\e[33m\]\w\[\e[0m\]]\n\[\e[32m\]\u@\H\[\e[0m\] \d \t \s.\v\nhist:\# jobs:\j \$ "
  62. export USER=$USERNAME
  63. fi
  64. _tmux_prefs(){
  65. null type tmux || return 1
  66. tmux set -g mode-keys vi
  67. }
  68. if test -d ~/dbx
  69. then
  70. export CHIT_PATH="$HOME/dbx/.chit"
  71. fi
  72. #######################
  73. iswindows && alias tty="echo cmd.exe"
  74. type fortune >/dev/null 2>&1 && {
  75. fortune
  76. echo
  77. fortune -o
  78. echo
  79. }
  80. uname -a
  81. echo TERM $TERM $(tput colors) colors connected to $(tty), \
  82. running $BASH $BASH_VERSION
  83. if test -n "$TMUX"
  84. then
  85. tmux display -p 'Using tmux #S:#I:#W.#P, client is #{client_termname}' \
  86. 2>/dev/null
  87. echo
  88. fi
  89. ###################################
  90. # some aliases and functions
  91. ( ! with_coreutils && isdarwin ) || test "$TERM" == dumb || \
  92. _coloroption=" --color=auto"
  93. ( ! with_coreutils && isdarwin ) || iswindows || \
  94. _timeoption=" --time-style=long-iso"
  95. ( ! with_coreutils && isdarwin ) || _hideoption=" --hide=[A-Z]*" # do not use
  96. _timeformat_iso="%Y-%m-%dT%H:%M:%S%z"
  97. _timeformat_rfc2822="%a, %d %b %Y %T %z"
  98. alias ls="ls -hCF${_coloroption}${_timeoption}"
  99. # export GREP_OPTIONS=""
  100. alias gr="grep -n --color=always"
  101. iswindows && alias grep="grep -n"
  102. # alias ll="ls -l"
  103. # alias la="ls -A"
  104. # alias lla="ls -Al"
  105. alias less="less -F"
  106. null type emacs && alias em="emacs -nw"
  107. null type vim && alias vi=vim
  108. alias pstree="LANG=C pstree"
  109. alias cp="cp -v"
  110. alias mv="mv -v"
  111. alias rm="rm -v"
  112. alias psaux="ps auxww"
  113. alias q=exit
  114. null type e3em && alias e3=e3em
  115. #alias dirs="dirs -v -l | \grep -v \$(printf '%s$' \$PWD)"
  116. alias po=popd
  117. alias pu=pushd
  118. alias sudo="sudo " # use aliases through sudo
  119. alias sudoe="sudoedit"
  120. alias halt="sudo halt"
  121. alias reboot="sudo reboot"
  122. null type dbus-send && {
  123. alias suspend="dbus-send --system --print-reply --dest=org.freedesktop.UPower \
  124. /org/freedesktop/UPower org.freedesktop.UPower.Suspend"
  125. alias hibernate="dbus-send --system --print-reply --dest=org.freedesktop.UPower \
  126. /org/freedesktop/UPower org.freedesktop.UPower.Hibernate"
  127. }
  128. alias rand="echo \$RANDOM"
  129. null type file-roller && alias xunp="file-roller -h"
  130. null type paco && alias pc="sudo \paco -D"
  131. alias pycalc="python -i -c 'from math import *' "
  132. null type python3 && alias py3=python3
  133. null type python2 && alias py2=python2
  134. alias _reloadrc="test -f ~/.bashrc && source ~/.bashrc"
  135. # alias mytime="date +%Y%m%d-%H%M%S"
  136. alias sh="ENV=$HOME/.shrc PS1=\$\ PROMPT_COMMAND="" sh"
  137. # type trash >/dev/null 2>&1 && alias rm=trash
  138. null type mpg123 && alias mpg123="mpg123 -C -v --title"
  139. null type xmms2 && alias xm="xmms2"
  140. #export PLAYER="mpg123 -C -v --title"
  141. null type screen && alias screen="screen -e^z^z"
  142. #alias zcd="cd \`zenity --file-selection --directory\`"
  143. null type gtags && alias gtags="gtags --verbose"
  144. null type htags && alias htags="htags --xhtml --symbol --line-number \
  145. --frame --alphabet --verbose"
  146. null type aunpack && alias aunp=aunpack
  147. null type lv && alias lv="lv|less"
  148. isdarwin && alias updatedb="LC_ALL=C updatedb"
  149. # pad
  150. alias pad=notepad
  151. null type gedit && alias pad=gedit
  152. null type leafpad && alias pad=leafpad
  153. isdarwin && alias pad="open -e"
  154. null type wicd-curses && alias wic=wicd-curses
  155. null type wicd-cli && alias wil="wicd-cli -y -l | head"
  156. #alias wicn="wicd-cli -y -c -n"
  157. wicn(){
  158. if test $# -eq 0
  159. then
  160. local num
  161. wicd-cli -y -l | head
  162. echo -n "input num: "
  163. read num
  164. test -n "$num" && wicd-cli -y -c -n $num
  165. else
  166. wicd-cli -y -c -n $1
  167. fi
  168. }
  169. for f in /usr/share/vim/vimcurrent/macros/less.sh \
  170. /usr/share/vim/vim73/macros/less.sh \
  171. /usr/share/vim/vim72/macros/less.sh
  172. do
  173. test -f $f && alias vl=$f && break
  174. done
  175. null type yaourt && alias yt=yaourt
  176. null type pacman-color && {
  177. alias pacman=pacman-color
  178. export pacman_program=pacman-color # used by pacmatic
  179. export PACMAN=pacman-color # used by yaourt
  180. }
  181. null type pacmatic && {
  182. alias pacman="pacmatic"
  183. export PACMAN="pacmatic"
  184. }
  185. null type apt-get && {
  186. alias aupgrade="sudo apt-get autoremove --yes && \
  187. sudo apt-get update --yes && sudo apt-get upgrade --yes"
  188. alias aptin="apt-get install"
  189. alias aptsearch="apt-cache search"
  190. alias aptshow="apt-cache show"
  191. }
  192. null type port && {
  193. alias port="port -v"
  194. alias pupgrade="sudo port -v selfupdate && \
  195. { sudo port -v upgrade outdated; }"
  196. }
  197. if iscygwin; then
  198. null type windate || \
  199. alias windate="/c/Windows/System32/cmd.exe //c 'echo %DATE%-%TIME%'"
  200. alias cygsu="cygstart /cygwinsetup.exe"
  201. alias emacs="CYGWIN=tty emacs -nw"
  202. alias ls="ls -CFG $(iswindows || test "$TERM" = dumb || echo --color=auto)"
  203. fi
  204. g(){
  205. if test $# -eq 0 && null type git-info
  206. then
  207. git info
  208. else
  209. git "$@"
  210. fi
  211. }
  212. if null type _git
  213. then
  214. # enable programmable completion for g
  215. complete -o bashdefault -o default -o nospace -F _git g 2>/dev/null \
  216. || complete -o default -o nospace -F _git g
  217. fi
  218. alias setup.py="sudo python3 setup.py install --record files.txt"
  219. clock(){
  220. (
  221. local tformat="%Y/%m/%d %H:%M:%S %z"
  222. local t=
  223. cal
  224. while true
  225. do
  226. t="`date "+${tformat}"`"
  227. printf "\\r$t"
  228. sleep 1
  229. done
  230. )
  231. }
  232. man(){
  233. env \
  234. LESS_TERMCAP_mb=$(printf "\e[1;35m") \
  235. LESS_TERMCAP_md=$(printf "\e[1;31m") \
  236. LESS_TERMCAP_me=$(printf "\e[0m") \
  237. LESS_TERMCAP_se=$(printf "\e[0m") \
  238. LESS_TERMCAP_so=$(printf "\e[1;44;33m") \
  239. LESS_TERMCAP_ue=$(printf "\e[0m") \
  240. LESS_TERMCAP_us=$(printf "\e[1;32m") \
  241. man "$@"
  242. }
  243. scr(){
  244. local _tformat="%Y%m%d-%H%M%S%z"
  245. local _file=`date +${_tformat}`.script
  246. SCRIPT=${_file} script ${_file} "$@"
  247. }
  248. netwait(){
  249. while ! ping -c 1 -t 1 example.com
  250. do
  251. true
  252. done
  253. echo network works.
  254. }
  255. cd(){
  256. if test $# -eq 0
  257. then
  258. pushd ~/ >/dev/null
  259. elif test $1 = -
  260. then
  261. local pwd="$PWD"
  262. command cd $OLDPWD
  263. pushd -n "$pwd" >/dev/null # stack last dir
  264. elif ! test -d "$1"
  265. then
  266. echo `basename ${SHELL}`: cd: "$1": No such file or directory 1>&2
  267. return 1
  268. else
  269. pushd "$1" >/dev/null
  270. fi
  271. __dirs_rm_dup "$PWD"
  272. echo "$PWD"
  273. }
  274. __dirs_rm_dup(){
  275. for d in "$@"
  276. do
  277. local next="$(__realpath --strip "$d")"
  278. for l in $(\dirs -v -l | cut -d $'\n' -f 2- | \
  279. \grep -x " *[0-9]\+ \+${next}" | \grep -o "^ *[0-9]\+ " | tac)
  280. do
  281. popd +$l -n >/dev/null
  282. done
  283. done
  284. }
  285. __realpath(){
  286. if type realpath >/dev/null 2>&1
  287. then
  288. command realpath "$@"
  289. else
  290. while ! test -d $1
  291. do
  292. shift
  293. done
  294. local d="$OLDPWD"
  295. command cd "$1"
  296. echo "$PWD"
  297. command cd "$d"
  298. fi
  299. }
  300. dh(){
  301. if test $# -eq 0
  302. then
  303. dirs -v -l
  304. else
  305. local dir="$(dirs -v -l | \grep "^ *$1 \+" | sed "s/^ *[0-9]* *//g")"
  306. cd "$dir"
  307. fi
  308. }
  309. input(){
  310. local foo
  311. stty -echo
  312. read foo
  313. stty echo
  314. echo $foo
  315. }
  316. tmux(){
  317. if test $# -eq 0
  318. then
  319. (cd ~; command tmux start;)
  320. if command tmux has -t main
  321. then
  322. command tmux attach -t main
  323. else
  324. (cd ~; command tmux new -s main;)
  325. fi
  326. else
  327. command tmux "$@"
  328. fi
  329. }
  330. mcrypt-stream(){
  331. test $# -eq 2 || return 1
  332. case $1 in
  333. en)
  334. mcrypt --key $2 | base64 ;;
  335. de)
  336. base64 -d | mcrypt -d --key $2 ;;
  337. esac
  338. }
  339. gpg-stream(){
  340. test $# -eq 2 || return 1
  341. case $1 in
  342. en)
  343. gpg --passphrase $2 -c --batch |base64 ;;
  344. de)
  345. base64 -d|gpg --passphrase $2 -d --batch ;;
  346. esac
  347. }
  348. dgpg(){
  349. if test "$1" = help || test -z "$2"
  350. then
  351. echo "dgpg: dgpg <en|de> <src-suffix> [<dst-suffix>]" 1>&2
  352. return
  353. fi
  354. local srcs="$2"
  355. local dsts="$3"
  356. test -z "$dsts" && dsts="${srcs}.out"
  357. local pw
  358. echo -n "dgpg pw: "
  359. read -s pw
  360. echo ""
  361. test -z "$pw" && return 1
  362. for f in *${srcs}
  363. do
  364. local d="$(basename "$f" "${srcs}")${dsts}"
  365. echo -n "Processing $f to $d..."
  366. if test -d "$f"
  367. then
  368. echo "`printf 'failed (%s is directory)' $f`"
  369. elif test -f "$d"
  370. then
  371. echo "`printf 'failed (%s is already exists)' $d`"
  372. elif <"$f" gpg-stream $1 $pw >"$d" 2>/dev/null
  373. then
  374. echo "done"
  375. else
  376. echo "failed"
  377. test -f "$d" && rm "$d"
  378. fi
  379. done
  380. }
  381. alias enst="gpg-stream en"
  382. alias dest="gpg-stream de"
  383. showinfo(){
  384. echo "Japanese letters are 表示可能"
  385. __try_exec diskinfo
  386. ! isdarwin && test -n "${DISPLAY}" && {
  387. __try_exec xrandr | \grep --color=never ^Screen
  388. }
  389. iswindows || __try_exec finger $USER
  390. LANG=C __try_exec id
  391. __try_exec xset q
  392. }
  393. x(){
  394. if [[ -z $DISPLAY ]] && ! [[ -e /tmp/.X11-unix/X0 ]] && (( EUID )); then
  395. #mkdir -p ~/.my/log
  396. # nohup startx >~/.my/log/xorg.log 2>&1 &
  397. # exit
  398. exec startx
  399. else
  400. echo "X cant be started! Another X is already running?" 1>&2
  401. fi
  402. }
  403. bak(){
  404. for file in "$@"
  405. do
  406. cp -v ${file} ${file}.bak
  407. done
  408. }
  409. di(){
  410. if type colordiff >/dev/null 2>&1 && test $TERM != dumb
  411. then
  412. local diffcmd=colordiff
  413. else
  414. local diffcmd=diff
  415. fi
  416. ${diffcmd} -u "$@" | ${PAGER}
  417. }
  418. tb(){
  419. local tb="$HOME/.my/tb"
  420. mkdir -p "$tb"
  421. for file in "$@"
  422. do
  423. mv -t "$tb" "$file"
  424. done
  425. }
  426. mkcd(){
  427. mkdir -p $1
  428. cd $1
  429. }
  430. if test -n "$TMUX" && null type reattach-to-user-namespace
  431. then
  432. alias pbpaste="reattach-to-user-namespace pbpaste"
  433. alias pbcopy="reattach-to-user-namespace pbcopy"
  434. fi
  435. catclip(){
  436. if iswindows
  437. then
  438. cat /dev/clipboard | tr -d \\r
  439. elif isdarwin
  440. then
  441. pbpaste
  442. else
  443. xclip -o -selection "clipboard"
  444. fi
  445. }
  446. setclip(){
  447. if test $# -eq 0
  448. then
  449. exec 3<&0
  450. else
  451. exec 3<<__EOF__
  452. `cat "$@"`
  453. __EOF__
  454. fi
  455. if iswindows
  456. then
  457. 0<&3 sed -e 's/$/\r/' | tee /dev/clipboard
  458. elif isdarwin
  459. then
  460. pbcopy 0<&3
  461. else
  462. 0<&3 xclip -i -f -selection "primary" | \
  463. xclip -i -f -selection "clipboard"
  464. fi
  465. exec 3<&-
  466. }
  467. open_file(){
  468. if iswindows
  469. then
  470. cmd.exe //c start "" "$@"
  471. elif isdarwin
  472. then
  473. touch "$@"
  474. open "$@"
  475. elif islinux
  476. then
  477. touch "$@"
  478. if null type pcmanfm; then
  479. LC_MESSAGES= pcmanfm "$@"
  480. else
  481. LC_MESSAGES= xdg-open "$@" &
  482. fi
  483. else
  484. cat "$@"
  485. fi
  486. }
  487. o(){
  488. if test $# -eq 0
  489. then
  490. open_file .
  491. else
  492. for f in "$@"
  493. do
  494. open_file "$(realpath "$f")"
  495. done
  496. fi
  497. }
  498. convmv-sjis2utf8-test(){
  499. convmv -r -f sjis -t utf8 *
  500. }
  501. convmv-sjis2utf8-notest(){
  502. convmv -r -f sjis -t utf8 * --notest
  503. }
  504. #Change ANSI Colors
  505. _chengecolors(){
  506. echo -e \
  507. "\e]P0000000" \
  508. "\e]P1cd0000" \
  509. "\e]P200cd00" \
  510. "\e]P3cdcd00" \
  511. "\e]P41e90ff" \
  512. "\e]P5cd00cd" \
  513. "\e]P600cdcd" \
  514. "\e]P7353535" \
  515. "\e]P8666666" \
  516. "\e]P9ff9999" \
  517. "\e]Pa99ff99" \
  518. "\e]Pbffff99" \
  519. "\e]Pc9999ff" \
  520. "\e]Pdff99ff" \
  521. "\e]Pe99ffff" \
  522. "\e]Pfffffff"
  523. }
  524. # printf "\e]P7353535" \
  525. _colors(){
  526. echo -e \
  527. "\e[30mBlack" \
  528. "\e[31mRed" \
  529. "\e[32mGreen" \
  530. "\e[33mYellow" \
  531. "\e[34mBlue" \
  532. "\e[35mMagenta" \
  533. "\e[36mCyan" \
  534. "\e[37mWhite"
  535. echo -e \
  536. "\e[30;1mBright Black" \
  537. "\e[31;1mBright Red" \
  538. "\e[32;1mBright Green" \
  539. "\e[33;1mBright Yellow" \
  540. "\e[34;1mBright Blue" \
  541. "\e[35;1mBright Magenta" \
  542. "\e[36;1mBright Cyan" \
  543. "\e[37;1mBright White\n" \
  544. "\e[0m"
  545. }
  546. winln(){
  547. # for windose make link (actually junction)
  548. if test $# -eq 0
  549. then
  550. {
  551. echo "usage: winln TARGET LINK_NAME"
  552. echo "Create a link to TARGET with the name LINK_NAME \
  553. (that is, TARGET must already exist)."
  554. echo "About other features run 'junction'."
  555. } 1>&2
  556. return 1
  557. else
  558. junction "$2" "$1"
  559. fi
  560. }
  561. __my_moc_state(){
  562. type mocp >/dev/null 2>&1 || return
  563. test "`mocp -Q %state 2>/dev/null`" == PLAY || return
  564. printf "$1" "`mocp -Q %title 2>/dev/null`"
  565. }
  566. __my_parse_svn_branch() {
  567. local LANG=C
  568. local svn_url=$(svn info 2>/dev/null | sed -ne 's#^URL: ##p')
  569. local svn_repository_root=$(svn info 2>/dev/null | \
  570. sed -ne 's#^Repository Root: ##p')
  571. echo ${svn_url} | sed -e 's#^'"${svn_repository_root}"'##g' | \
  572. awk '{print $1}'
  573. }
  574. __my_svn_ps1(){
  575. if svn status >/dev/null 2>&1
  576. then
  577. local svn_branch=$(__my_parse_svn_branch)
  578. test -n "${svn_branch}" && printf "$1" "{$svn_branch}"
  579. fi
  580. }
  581. __my_battery_status(){
  582. local dir=/sys/class/power_supply/BAT0
  583. if test -d $dir && test -r $dir/status && test -r $dir/charge_full && \
  584. test -r $dir/charge_now
  585. then
  586. local st=$(cat $dir/status)
  587. local full=$(cat $dir/charge_full)
  588. local now=$(cat $dir/charge_now)
  589. local rate=$(expr $now \* 100 / $full)
  590. printf "$1" "${st}:${rate}%"
  591. fi
  592. }
  593. alias bat='__my_battery_status %s\\n'
  594. ip-address(){
  595. type ip >/dev/null 2>&1 || return 1
  596. local ip=$(LANG=C ip addr show scope global | \
  597. \grep --color=never --only-matching 'inet [^ ]*' | cut -d " " -f 2)
  598. test -n "$ip" && printf $1 $ip
  599. }
  600. __my_ps1_script(){
  601. local last=$?
  602. test -n "$SCRIPT" && echo "${__my_c5}SCR${__my_cdef} "
  603. return $last
  604. }
  605. __my_ps1_scale(){
  606. local last=$?
  607. echo "[LC:${LINES}x${COLUMNS}]"
  608. return $last
  609. }
  610. __my_ps1_tmux(){
  611. local last=$?
  612. null type tmux || return $last
  613. local tmuxc="$(tmux display -p '#S:#I:#W.#P' 2>/dev/null)"
  614. test -n "$TMUX" && echo "[TMUX:$tmuxc]"
  615. return $last
  616. }
  617. __my_ps1_moc(){
  618. local last=$?
  619. __my_moc_state "[MOC:%s]"
  620. return $last
  621. }
  622. for f in /usr/share/git/git-prompt.sh \
  623. /opt/local/share/doc/git-core/contrib/completion/git-prompt.sh
  624. do
  625. test -r $f && . $f && break
  626. done
  627. GIT_PS1_SHOWDIRTYSTATE=t
  628. GIT_PS1_SHOWUPSTREAM=t
  629. __my_ps1_git(){
  630. local last=$?
  631. null type __git_ps1 || return $last
  632. null __gitdir || return $last
  633. __git_ps1 "[GIT:$(__try_exec git config --get user.name):%s]"
  634. return $last
  635. }
  636. __my_ps1_ipaddr(){
  637. local last=$?
  638. ! iswindows && ip-address [Addr:%s]
  639. return $last
  640. }
  641. __my_ps1_bttry(){
  642. local last=$?
  643. local bst="${TMP}/batterystatus"
  644. if test -z "$DISPLAY" && ! iswindows
  645. then
  646. test -f $bst && local bstr="$(cat $bst)"
  647. test -n "$bstr" && ! echo $bstr | grep 100 >/dev/null 2>&1 && \
  648. echo "[Battery:$bstr]"
  649. __my_battery_status %s >$bst &
  650. fi
  651. return $last
  652. }
  653. __my_ps1_dirs(){
  654. dirs | wc -l
  655. }
  656. __my_ps1_jobs(){
  657. jobs | wc -l
  658. }
  659. if test "$TERM" != dumb
  660. then
  661. __my_c1="\[\e[1;31m\]" # color for PWD
  662. __my_c2="\[\e[0;36m\]" # color for user
  663. __my_c3="\[\e[1;30m\]" # color for OLDPWD
  664. if test "`hostname`" = arch-aspireone; then __my_c4="\[\e[1;34m\]"
  665. elif test "`hostname`" = darwin-mba.local; then __my_c4="\[\e[1;33m\]"
  666. elif test "`hostname`" = newkiwi; then __my_c4="\[\e[1;35m\]"
  667. else __my_c4="\[\e[1;32m\]" # color for ::
  668. fi
  669. __my_c5="\[\e[30;47m\]" # color for SCR
  670. __my_cdef="\[\e[0m\]"
  671. fi
  672. _PS1="\
  673. ${__my_c4}:: ${__my_cdef}[${__my_c2}\u@\H${__my_cdef}:${__my_c1}\w/${__my_cdef}]\$(__my_ps1_scale)\$(__my_ps1_git)\$(__my_ps1_bttry)\$(__my_ps1_ipaddr)\$(__my_ps1_moc)\n\
  674. ${__my_c4}:: ${__my_cdef}l${SHLVL}n\#j\js\$? \D{%T} $(__my_ps1_script)\$ "
  675. PS1=$_PS1
  676. __my_set_title(){
  677. title="$(echo $@)"
  678. case $TERM in
  679. (rxvt*|xterm*|aterm|screen*)
  680. test -t 1 &&
  681. test -n "$DISPLAY" &&
  682. test -z "$EMACS" &&
  683. echo -n -e "\033]0;${title}\007"
  684. ;;
  685. esac
  686. }
  687. PROMPT_COMMAND="__my_set_title \${USER}@\${HOSTNAME}\ \${PWD}"
  688. # copied from https://wiki.archlinux.org/index.php/X_resources
  689. invader(){
  690. # ANSI color scheme script featuring Space Invaders
  691. #
  692. # Original: http://crunchbanglinux.org/forums/post/126921/#p126921
  693. # Modified by lolilolicon
  694. #
  695. f=3 b=4
  696. for j in f b; do
  697. for i in {0..7}; do
  698. printf -v $j$i %b "\e[${!j}${i}m"
  699. done
  700. done
  701. bld=$'\e[1m'
  702. rst=$'\e[0m'
  703. cat << EOF
  704. $f1 ▀▄ ▄▀ $f2 ▄▄▄████▄▄▄ $f3 ▄██▄ $f4 ▀▄ ▄▀ $f5 ▄▄▄████▄▄▄ $f6 ▄██▄ $rst
  705. $f1 ▄█▀███▀█▄ $f2███▀▀██▀▀███ $f3▄█▀██▀█▄ $f4 ▄█▀███▀█▄ $f5███▀▀██▀▀███ $f6▄█▀██▀█▄$rst
  706. $f1█▀███████▀█ $f2▀▀███▀▀███▀▀ $f3▀█▀██▀█▀ $f4█▀███████▀█ $f5▀▀███▀▀███▀▀ $f6▀█▀██▀█▀$rst
  707. $f1▀ ▀▄▄ ▄▄▀ ▀ $f2 ▀█▄ ▀▀ ▄█▀ $f3▀▄ ▄▀ $f4▀ ▀▄▄ ▄▄▀ ▀ $f5 ▀█▄ ▀▀ ▄█▀ $f6▀▄ ▄▀$rst
  708. $bld$f1▄ ▀▄ ▄▀ ▄ $f2 ▄▄▄████▄▄▄ $f3 ▄██▄ $f4▄ ▀▄ ▄▀ ▄ $f5 ▄▄▄████▄▄▄ $f6 ▄██▄ $rst
  709. $bld$f1█▄█▀███▀█▄█ $f2███▀▀██▀▀███ $f3▄█▀██▀█▄ $f4█▄█▀███▀█▄█ $f5███▀▀██▀▀███ $f6▄█▀██▀█▄$rst
  710. $bld$f1▀█████████▀ $f2▀▀▀██▀▀██▀▀▀ $f3▀▀█▀▀█▀▀ $f4▀█████████▀ $f5▀▀▀██▀▀██▀▀▀ $f6▀▀█▀▀█▀▀$rst
  711. $bld$f1 ▄▀ ▀▄ $f2▄▄▀▀ ▀▀ ▀▀▄▄ $f3▄▀▄▀▀▄▀▄ $f4 ▄▀ ▀▄ $f5▄▄▀▀ ▀▀ ▀▀▄▄ $f6▄▀▄▀▀▄▀▄$rst
  712. $f7▌$rst
  713. $f7▌$rst
  714. $f7 ▄█▄ $rst
  715. $f7▄█████████▄$rst
  716. $f7▀▀▀▀▀▀▀▀▀▀▀$rst
  717. EOF
  718. }
  719. #/etc/lsb-release